/**
 * Fuse.js v6.0.0-beta.0 - Lightweight fuzzy-search (http://fusejs.io)
 *
 * Copyright (c) 2020 Kiro Risk (http://kiro.me)
 * All Rights Reserved. Apache Software License 2.0
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 */
var e,t;e=this,t=function(){"use strict";function e(t){return(e="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(t)}function t(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function n(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function r(e,t,r){return t&&n(e.prototype,t),r&&n(e,r),e}function i(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function o(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r)}return n}function a(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{};t%2?o(Object(n),!0).forEach((function(t){i(e,t,n[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(n)):o(Object(n)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(n,t))}))}return e}function c(e){return function(e){if(Array.isArray(e))return s(e)}(e)||function(e){if("undefined"!=typeof Symbol&&Symbol.iterator in Object(e))return Array.from(e)}(e)||function(e,t){if(e){if("string"==typeof e)return s(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(n):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?s(e,t):void 0}}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function s(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function h(e){return Array.isArray?Array.isArray(e):"[object Array]"===Object.prototype.toString.call(e)}function u(e){return"string"==typeof e}function f(e){return"number"==typeof e}function l(e){return null!=e}function d(e){return!e.trim().length}var v=Object.prototype.hasOwnProperty,y=function(){function e(n){var r=this;t(this,e),this._keys={},this._keyNames=[];var i=0;n.forEach((function(e){var t,n=1;if(u(e))t=e;else{if(!v.call(e,"name"))throw new Error("Key must contain a name");if(t=e.name,v.call(e,"weight")&&(n=e.weight)<=0)throw new Error('"weight" property in key must be a positive integer')}r._keyNames.push(t),r._keys[t]={weight:n},i+=n})),this._keyNames.forEach((function(e){r._keys[e].weight/=i}))}return r(e,[{key:"get",value:function(e,t){return this._keys[e]&&this._keys[e][t]}},{key:"keys",value:function(){return this._keyNames}},{key:"toJSON",value:function(){return JSON.stringify(this._keys)}}]),e}(),p=a({},{isCaseSensitive:!1,includeScore:!1,keys:[],shouldSort:!0,sortFn:function(e,t){return e.score===t.score?e.idx<t.idx?-1:1:e.score<t.score?-1:1}},{},{includeMatches:!1,findAllMatches:!1,minMatchCharLength:1},{},{location:0,threshold:.6,distance:100},{},{useExtendedSearch:!1,getFn:function(e,t){var n=[],r=!1;return function e(t,i){if(i){var o=i.indexOf("."),a=i,c=null;-1!==o&&(a=i.slice(0,o),c=i.slice(o+1));var s=t[a];if(l(s))if(c||!u(s)&&!f(s))if(h(s)){r=!0;for(var d=0,v=s.length;d<v;d+=1)e(s[d],c)}else c&&e(s,c);else n.push(function(e){return null==e?"":function(e){if("string"==typeof e)return e;var t=e+"";return"0"==t&&1/e==-1/0?"-0":t}(e)}(s))}else n.push(t)}(e,t),r?n:n[0]}}),g=/[^ ]+/g;function m(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:3,t=new Map;return{get:function(n){var r=n.match(g).length;if(t.has(r))return t.get(r);var i=parseFloat((1/Math.sqrt(r)).toFixed(e));return t.set(r,i),i},clear:function(){t.clear()}}}var k=function(){function e(){var n=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},r=n.getFn,i=void 0===r?p.getFn:r;t(this,e),this.norm=m(3),this.getFn=i,this.isCreated=!1,this.setRecords()}return r(e,[{key:"setCollection",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[];this.docs=e}},{key:"setRecords",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[];this.records=e}},{key:"setKeys",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[];this.keys=e}},{key:"create",value:function(){var e=this;!this.isCreated&&this.docs.length&&(this.isCreated=!0,u(this.docs[0])?this.docs.forEach((function(t,n){e._addString(t,n)})):this.docs.forEach((function(t,n){e._addObject(t,n)})),this.norm.clear())}},{key:"add",value:function(e){var t=this.size();u(e)?this._addString(e,t):this._addObject(e,t)}},{key:"removeAt",value:function(e){this.records.splice(e,1);for(var t=e,n=this.size();t<n;t+=1)this.records[t].i-=1}},{key:"size",value:function(){return this.records.length}},{key:"_addString",value:function(e,t){if(l(e)&&!d(e)){var n={v:e,i:t,n:this.norm.get(e)};this.records.push(n)}}},{key:"_addObject",value:function(e,t){var n=this,r={i:t,$:{}};this.keys.forEach((function(t,i){var o=n.getFn(e,t);if(l(o))if(h(o))!function(){for(var e=[],t=[{nestedArrIndex:-1,value:o}];t.length;){var a=t.pop(),c=a.nestedArrIndex,s=a.value;if(l(s))if(u(s)&&!d(s)){var f={v:s,i:c,n:n.norm.get(s)};e.push(f)}else h(s)&&s.forEach((function(e,n){t.push({nestedArrIndex:n,value:e})}))}r.$[i]=e}();else if(!d(o)){var a={v:o,n:n.norm.get(o)};r.$[i]=a}})),this.records.push(r)}},{key:"toJSON",value:function(){return{keys:this.keys,records:this.records}}}]),e}();function b(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},r=n.getFn,i=void 0===r?p.getFn:r,o=new k({getFn:i});return o.setKeys(e),o.setCollection(t),o.create(),o}function M(e,t){var n=e.matches;if(t.matches=[],l(n))for(var r=0,i=n.length;r<i;r+=1){var o=n[r];if(l(o.indices)&&0!==o.indices.length){var a={indices:o.indices,value:o.value};o.key&&(a.key=o.key),o.idx>-1&&(a.refIndex=o.idx),t.matches.push(a)}}}function x(e,t){t.score=e.score}function _(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},n=t.errors,r=void 0===n?0:n,i=t.currentLocation,o=void 0===i?0:i,a=t.expectedLocation,c=void 0===a?0:a,s=t.distance,h=void 0===s?p.distance:s,u=r/e.length,f=Math.abs(c-o);return h?u+f/h:f?1:u}function w(){for(var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[],t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:p.minMatchCharLength,n=[],r=-1,i=-1,o=0,a=e.length;o<a;o+=1){var c=e[o];c&&-1===r?r=o:c||-1===r||((i=o-1)-r+1>=t&&n.push([r,i]),r=-1)}return e[o-1]&&o-r>=t&&n.push([r,o-1]),n}function O(e){for(var t={},n=e.length,r=0;r<n;r+=1)t[e.charAt(r)]=0;for(var i=0;i<n;i+=1)t[e.charAt(i)]|=1<<n-i-1;return t}var S=function(){function e(n){var r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},i=r.location,o=void 0===i?p.location:i,a=r.threshold,c=void 0===a?p.threshold:a,s=r.distance,h=void 0===s?p.distance:s,u=r.includeMatches,f=void 0===u?p.includeMatches:u,l=r.findAllMatches,d=void 0===l?p.findAllMatches:l,v=r.minMatchCharLength,y=void 0===v?p.minMatchCharLength:v,g=r.isCaseSensitive,m=void 0===g?p.isCaseSensitive:g;t(this,e),this.options={location:o,threshold:c,distance:h,includeMatches:f,findAllMatches:d,minMatchCharLength:y,isCaseSensitive:m},this.pattern=m?n:n.toLowerCase(),this.chunks=[];for(var k=0;k<this.pattern.length;){var b=this.pattern.substring(k,k+32);this.chunks.push({pattern:b,alphabet:O(b)}),k+=32}}return r(e,[{key:"searchIn",value:function(e){var t=this.options,n=t.isCaseSensitive,r=t.includeMatches;if(n||(e=e.toLowerCase()),this.pattern===e){var i={isMatch:!0,score:0};return r&&(i.indices=[[0,e.length-1]]),i}var o=this.options,a=o.location,s=o.distance,h=o.threshold,u=o.findAllMatches,f=o.minMatchCharLength,l=[],d=0,v=!1;this.chunks.forEach((function(t,n){var i=t.pattern,o=t.alphabet,y=function(e,t,n){var r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},i=r.location,o=void 0===i?p.location:i,a=r.distance,c=void 0===a?p.distance:a,s=r.threshold,h=void 0===s?p.threshold:s,u=r.findAllMatches,f=void 0===u?p.findAllMatches:u,l=r.minMatchCharLength,d=void 0===l?p.minMatchCharLength:l,v=r.includeMatches,y=void 0===v?p.includeMatches:v;if(t.length>32)throw new Error("Pattern length exceeds max of ".concat(32,"."));var g,m=t.length,k=e.length,b=Math.max(0,Math.min(o,k)),M=h,x=b,O=[];if(y)for(var S=0;S<k;S+=1)O[S]=0;for(;(g=e.indexOf(t,x))>-1;){var A=_(t,{currentLocation:g,expectedLocation:b,distance:c});if(M=Math.min(A,M),x=g+m,y)for(var j=0;j<m;)O[g+j]=1,j+=1}x=-1;for(var E=[],C=1,I=m+k,L=1<<(m<=31?m-1:30),F=0;F<m;F+=1){for(var P=0,N=I;P<N;){var $=_(t,{errors:F,currentLocation:b+N,expectedLocation:b,distance:c});$<=M?P=N:I=N,N=Math.floor((I-P)/2+P)}I=N;var D=Math.max(1,b-N+1),K=f?k:Math.min(b+N,k)+m,W=Array(K+2);W[K+1]=(1<<F)-1;for(var z=K;z>=D;z-=1){var J=z-1,R=n[e.charAt(J)];if(R&&y&&(O[J]=1),W[z]=(W[z+1]<<1|1)&R,0!==F&&(W[z]|=(E[z+1]|E[z])<<1|1|E[z+1]),W[z]&L&&(C=_(t,{errors:F,currentLocation:J,expectedLocation:b,distance:c}))<=M){if(M=C,(x=J)<=b)break;D=Math.max(1,2*b-x)}}var T=_(t,{errors:F+1,currentLocation:b,expectedLocation:b,distance:c});if(T>M)break;E=W}var q={isMatch:x>=0,score:Math.max(.001,C)};return y&&(q.indices=w(O,d)),q}(e,i,o,{location:a+32*n,distance:s,threshold:h,findAllMatches:u,minMatchCharLength:f,includeMatches:r}),g=y.isMatch,m=y.score,k=y.indices;g&&(v=!0),d+=m,g&&k&&(l=[].concat(c(l),c(k)))}));var y={isMatch:v,score:v?d/this.chunks.length:1};return v&&r&&(y.indices=l),y}}]),e}(),A=[];function j(e,t){for(var n=0,r=A.length;n<r;n+=1){var i=A[n];if(i.condition(e,t))return new i(e,t)}return new S(e,t)}var E="$and",C="$or",I=function(e){return!(!e[E]&&!e[C])},L=function(t){return!h(t)&&"object"===e(t)&&!I(t)},F=function(e){return i({},E,Object.keys(e).map((function(t){return i({},t,e[t])})))},P=function(){function e(n){var r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},i=arguments.length>2?arguments[2]:void 0;t(this,e),this.options=a({},p,{},r),this._keyStore=new y(this.options.keys),this.setCollection(n,i)}return r(e,[{key:"setCollection",value:function(e,t){if(this._docs=e,t&&!(t instanceof k))throw new Error("Incorrect index type");this._myIndex=t||b(this._keyStore.keys(),this._docs,{getFn:this.options.getFn})}},{key:"add",value:function(e){l(e)&&(this._docs.push(e),this._myIndex.add(e))}},{key:"removeAt",value:function(e){this._docs.splice(e,1),this._myIndex.removeAt(e)}},{key:"getIndex",value:function(){return this._myIndex}},{key:"search",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},n=t.limit,r=void 0===n?-1:n,i=[],o=this.options,a=o.includeMatches,c=o.includeScore,s=o.shouldSort,h=o.sortFn;if(u(e)){var l=j(e,this.options);i=u(this._docs[0])?this._searchStringArrayWith(l):this._searchObjectArrayWith(l)}else i=this._searchLogical(e);return N(i,this._keyStore),s&&i.sort(h),f(r)&&r>-1&&(i=i.slice(0,r)),$(i,this._docs,{includeMatches:a,includeScore:c})}},{key:"_searchStringArrayWith",value:function(e){var t=this._myIndex.records,n=[];return t.forEach((function(t){var r=t.v,i=t.i,o=t.n;if(l(r)){var a=e.searchIn(r),c=a.isMatch,s=a.score,h=a.indices;c&&n.push({item:r,idx:i,matches:[{score:s,value:r,norm:o,indices:h}]})}})),n}},{key:"_searchLogical",value:function(e){var t=this,n=function(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},r=n.auto,i=void 0===r||r,o=function e(n){var r=Object.keys(n);if(r.length>1&&!I(n))return e(F(n));var o=r[0];if(L(n)){var a=n[o];if(!u(a))throw new Error('Invalid value for key "'.concat(o,'"'));var c={key:o,pattern:a};return i&&(c.searcher=j(a,t)),c}var s={children:[],operator:o};return r.forEach((function(t){var r=n[t];h(r)&&r.forEach((function(t){s.children.push(e(t))}))})),s};return I(e)||(e=F(e)),o(e)}(e,this.options),r=this._myIndex,i=r.keys,o=r.records,a={},s=[];return o.forEach((function(e){var r=e.$,o=e.i;l(r)&&function e(n,r,o){if(!n.children){var h=n.key,u=n.searcher,f=r[i.indexOf(h)];return t._findMatches({key:h,value:f,searcher:u})}for(var l=n.operator,d=[],v=0;v<n.children.length;v+=1){var y=e(n.children[v],r,o);if(y&&y.length){if(d.push({idx:o,item:r,matches:y}),l===C)break}else if(l===E){d.length=0;break}}d.length&&(a[o]||(a[o]={idx:o,item:r,matches:[]},s.push(a[o])),d.forEach((function(e){var t,n=e.matches;(t=a[o].matches).push.apply(t,c(n))})))}(n,r,o)})),s}},{key:"_searchObjectArrayWith",value:function(e){var t=this,n=this._myIndex,r=n.keys,i=n.records,o=[];return i.forEach((function(n){var i=n.$,a=n.i;if(l(i)){var s=[];r.forEach((function(n,r){s.push.apply(s,c(t._findMatches({key:n,value:i[r],searcher:e})))})),s.length&&o.push({idx:a,item:i,matches:s})}})),o}},{key:"_findMatches",value:function(e){var t=e.key,n=e.value,r=e.searcher;if(!l(n))return[];var i=[];if(h(n))n.forEach((function(e){var n=e.v,o=e.i,a=e.n;if(l(n)){var c=r.searchIn(n),s=c.isMatch,h=c.score,u=c.indices;s&&i.push({score:h,key:t,value:n,idx:o,norm:a,indices:u})}}));else{var o=n.v,a=n.n,c=r.searchIn(o),s=c.isMatch,u=c.score,f=c.indices;s&&i.push({score:u,key:t,value:o,norm:a,indices:f})}return i}}]),e}();function N(e,t){e.forEach((function(e){var n=1;e.matches.forEach((function(e){var r=e.key,i=e.norm,o=e.score,a=t.get(r,"weight");n*=Math.pow(0===o&&a?Number.EPSILON:o,(a||1)*i)})),e.score=n}))}function $(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},r=n.includeMatches,i=void 0===r?p.includeMatches:r,o=n.includeScore,a=void 0===o?p.includeScore:o,c=[];return i&&c.push(M),a&&c.push(x),e.map((function(e){var n=e.idx,r={item:t[n],refIndex:n};return c.length&&c.forEach((function(t){t(e,r)})),r}))}return P.version="6.0.0-beta.0",P.createIndex=b,P.parseIndex=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},n=t.getFn,r=void 0===n?p.getFn:n,i=e.keys,o=e.records,a=new k({getFn:r});return a.setKeys(i),a.setRecords(o),a},P.config=p,P},"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):(e=e||self).Fuse=t();